
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>C#,Java,C -循环冗余检验：CRC-16-CCITT查表法 / iVAN</title>

    <meta name="description" content="C#,Java,C -循环冗余检验：CRC-16-CCITT查表法 C#代码 1 using System; 2 using System.Collections.Generic; 3 using System.Linq; 4 using System.Text; 5 6 namespace TestCRC 7 { 8 /// &lt;summary&gt; 9 /// 循环冗余检验:CRC-16-CCITT查表法 10 /// &lt;/summary&gt; 11 public static partial class CRCITU 12 { 13 ///  ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">C#,Java,C -循环冗余检验：CRC-16-CCITT查表法</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>C#代码</h2>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg"></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>  1 using System;
  2 using System.Collections.Generic;
  3 using System.Linq;
  4 using System.Text;
  5
  6 namespace TestCRC
  7 {
  8     /// &lt;summary&gt;
  9     /// 循环冗余检验：CRC-16-CCITT查表法
 10     /// &lt;/summary&gt;
 11     public static partial class CRCITU
 12     {
 13         /// &lt;summary&gt;
 14         /// 计算给定长度数据的16位CRC
 15         /// &lt;/summary&gt;
 16         /// &lt;param name="data"&gt;要计算CRC的字节数组&lt;/param&gt;
 17         /// &lt;returns&gt;CRC值&lt;/returns&gt;
 18         public static UInt16 GetCrc16(Byte[] data)
 19         {   // 初始化
 20             Int32 High = 0xFF;  // 高字节
 21             Int32 Low = 0xFF;   // 低字节
 22             if (data != null)
 23             {
 24                 foreach (Byte b in data)
 25                 {
 26                     Int32 Index = Low ^ b;
 27                     Low = High ^ CRC16TABLE_LO[Index];
 28                     High = CRC16TABLE_HI[Index];
 29                 }
 30             }
 31             return (UInt16)(~((High &lt;&lt; 8) + Low));    // 取反
 32         }
 33
 34         /// &lt;summary&gt;
 35         /// 检查给定长度数据的16位CRC是否正确
 36         /// &lt;/summary&gt;
 37         /// &lt;param name="data"&gt;要校验的字节数组&lt;/param&gt;
 38         /// &lt;returns&gt;
 39         ///     true：正确
 40         ///     false：错误
 41         /// &lt;/returns&gt;
 42         /// &lt;reamrks&gt;
 43         /// 字节数组最后2个字节为校验码，且低字节在前面，高字节在后面
 44         /// &lt;/reamrks&gt;
 45         public static Boolean IsCrc16Good(Byte[] data)
 46         {
 47             // 初始化
 48             Int32 High = 0xFF;
 49             Int32 Low = 0xFF;
 50             if (data != null)
 51             {
 52                 foreach (Byte b in data)
 53                 {
 54                     Int32 Index = Low ^ b;
 55                     Low = High ^ CRC16TABLE_LO[Index];
 56                     High = CRC16TABLE_HI[Index];
 57                 }
 58             }
 59
 60             return (High == 0xF0 &amp;&amp; Low == 0xB8);
 61         }
 62
 63         /// &lt;summary&gt;
 64         /// CRC16查找表高字节
 65         /// &lt;/summary&gt;
 66         private static readonly Byte[] CRC16TABLE_HI =
 67         {
 68             0x00, 0x11, 0x23, 0x32, 0x46, 0x57, 0x65, 0x74, 0x8C, 0x9D, 0xAF, 0xBE, 0xCA, 0xDB, 0xE9, 0xF8,
 69             0x10, 0x01, 0x33, 0x22, 0x56, 0x47, 0x75, 0x64, 0x9C, 0x8D, 0xBF, 0xAE, 0xDA, 0xCB, 0xF9, 0xE8,
 70             0x21, 0x30, 0x02, 0x13, 0x67, 0x76, 0x44, 0x55, 0xAD, 0xBC, 0x8E, 0x9F, 0xEB, 0xFA, 0xC8, 0xD9,
 71             0x31, 0x20, 0x12, 0x03, 0x77, 0x66, 0x54, 0x45, 0xBD, 0xAC, 0x9E, 0x8F, 0xFB, 0xEA, 0xD8, 0xC9,
 72             0x42, 0x53, 0x61, 0x70, 0x04, 0x15, 0x27, 0x36, 0xCE, 0xDF, 0xED, 0xFC, 0x88, 0x99, 0xAB, 0xBA,
 73             0x52, 0x43, 0x71, 0x60, 0x14, 0x05, 0x37, 0x26, 0xDE, 0xCF, 0xFD, 0xEC, 0x98, 0x89, 0xBB, 0xAA,
 74             0x63, 0x72, 0x40, 0x51, 0x25, 0x34, 0x06, 0x17, 0xEF, 0xFE, 0xCC, 0xDD, 0xA9, 0xB8, 0x8A, 0x9B,
 75             0x73, 0x62, 0x50, 0x41, 0x35, 0x24, 0x16, 0x07, 0xFF, 0xEE, 0xDC, 0xCD, 0xB9, 0xA8, 0x9A, 0x8B,
 76             0x84, 0x95, 0xA7, 0xB6, 0xC2, 0xD3, 0xE1, 0xF0, 0x08, 0x19, 0x2B, 0x3A, 0x4E, 0x5F, 0x6D, 0x7C,
 77             0x94, 0x85, 0xB7, 0xA6, 0xD2, 0xC3, 0xF1, 0xE0, 0x18, 0x09, 0x3B, 0x2A, 0x5E, 0x4F, 0x7D, 0x6C,
 78             0xA5, 0xB4, 0x86, 0x97, 0xE3, 0xF2, 0xC0, 0xD1, 0x29, 0x38, 0x0A, 0x1B, 0x6F, 0x7E, 0x4C, 0x5D,
 79             0xB5, 0xA4, 0x96, 0x87, 0xF3, 0xE2, 0xD0, 0xC1, 0x39, 0x28, 0x1A, 0x0B, 0x7F, 0x6E, 0x5C, 0x4D,
 80             0xC6, 0xD7, 0xE5, 0xF4, 0x80, 0x91, 0xA3, 0xB2, 0x4A, 0x5B, 0x69, 0x78, 0x0C, 0x1D, 0x2F, 0x3E,
 81             0xD6, 0xC7, 0xF5, 0xE4, 0x90, 0x81, 0xB3, 0xA2, 0x5A, 0x4B, 0x79, 0x68, 0x1C, 0x0D, 0x3F, 0x2E,
 82             0xE7, 0xF6, 0xC4, 0xD5, 0xA1, 0xB0, 0x82, 0x93, 0x6B, 0x7A, 0x48, 0x59, 0x2D, 0x3C, 0x0E, 0x1F,
 83             0xF7, 0xE6, 0xD4, 0xC5, 0xB1, 0xA0, 0x92, 0x83, 0x7B, 0x6A, 0x58, 0x49, 0x3D, 0x2C, 0x1E, 0x0F
 84         };
 85
 86         /// &lt;summary&gt;
 87         /// CRC16查找表低字节
 88         /// &lt;/summary&gt;
 89         private static readonly Byte[] CRC16TABLE_LO =
 90         {
 91             0x00, 0x89, 0x12, 0x9B, 0x24, 0xAD, 0x36, 0xBF, 0x48, 0xC1, 0x5A, 0xD3, 0x6C, 0xE5, 0x7E, 0xF7,
 92             0x81, 0x08, 0x93, 0x1A, 0xA5, 0x2C, 0xB7, 0x3E, 0xC9, 0x40, 0xDB, 0x52, 0xED, 0x64, 0xFF, 0x76,
 93             0x02, 0x8B, 0x10, 0x99, 0x26, 0xAF, 0x34, 0xBD, 0x4A, 0xC3, 0x58, 0xD1, 0x6E, 0xE7, 0x7C, 0xF5,
 94             0x83, 0x0A, 0x91, 0x18, 0xA7, 0x2E, 0xB5, 0x3C, 0xCB, 0x42, 0xD9, 0x50, 0xEF, 0x66, 0xFD, 0x74,
 95             0x04, 0x8D, 0x16, 0x9F, 0x20, 0xA9, 0x32, 0xBB, 0x4C, 0xC5, 0x5E, 0xD7, 0x68, 0xE1, 0x7A, 0xF3,
 96             0x85, 0x0C, 0x97, 0x1E, 0xA1, 0x28, 0xB3, 0x3A, 0xCD, 0x44, 0xDF, 0x56, 0xE9, 0x60, 0xFB, 0x72,
 97             0x06, 0x8F, 0x14, 0x9D, 0x22, 0xAB, 0x30, 0xB9, 0x4E, 0xC7, 0x5C, 0xD5, 0x6A, 0xE3, 0x78, 0xF1,
 98             0x87, 0x0E, 0x95, 0x1C, 0xA3, 0x2A, 0xB1, 0x38, 0xCF, 0x46, 0xDD, 0x54, 0xEB, 0x62, 0xF9, 0x70,
 99             0x08, 0x81, 0x1A, 0x93, 0x2C, 0xA5, 0x3E, 0xB7, 0x40, 0xC9, 0x52, 0xDB, 0x64, 0xED, 0x76, 0xFF,
100             0x89, 0x00, 0x9B, 0x12, 0xAD, 0x24, 0xBF, 0x36, 0xC1, 0x48, 0xD3, 0x5A, 0xE5, 0x6C, 0xF7, 0x7E,
101             0x0A, 0x83, 0x18, 0x91, 0x2E, 0xA7, 0x3C, 0xB5, 0x42, 0xCB, 0x50, 0xD9, 0x66, 0xEF, 0x74, 0xFD,
102             0x8B, 0x02, 0x99, 0x10, 0xAF, 0x26, 0xBD, 0x34, 0xC3, 0x4A, 0xD1, 0x58, 0xE7, 0x6E, 0xF5, 0x7C,
103             0x0C, 0x85, 0x1E, 0x97, 0x28, 0xA1, 0x3A, 0xB3, 0x44, 0xCD, 0x56, 0xDF, 0x60, 0xE9, 0x72, 0xFB,
104             0x8D, 0x04, 0x9F, 0x16, 0xA9, 0x20, 0xBB, 0x32, 0xC5, 0x4C, 0xD7, 0x5E, 0xE1, 0x68, 0xF3, 0x7A,
105             0x0E, 0x87, 0x1C, 0x95, 0x2A, 0xA3, 0x38, 0xB1, 0x46, 0xCF, 0x54, 0xDD, 0x62, 0xEB, 0x70, 0xF9,
106             0x8F, 0x06, 0x9D, 0x14, 0xAB, 0x22, 0xB9, 0x30, 0xC7, 0x4E, 0xD5, 0x5C, 0xE3, 0x6A, 0xF1, 0x78
107         };
108     }
109 }</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p> </p>
<h2>Java代码</h2>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg"></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>  1 import com.example.utils.BitConverter;
  2
  3
  4
  5 /**
  6  * 循环冗余检验：CRC-16-CCITT查表法
  7  */
  8 public final class CRC16 {
  9
 10     public static void main(String[] args) {
 11         short result=CRC16.GetCrc16(new byte[]{1,2,3});
 12         System.out.println(Integer.toHexString(result));
 13     }
 14     /**
 15      * 计算给定长度数据的16位CRC
 16      *
 17      * @param data
 18      *            要计算CRC的字节数组
 19      * @return CRC值
 20      */
 21     public static short GetCrc16(byte[] data) { // 初始化
 22         int High = 0xFF; // 高字节
 23         int Low = 0xFF; // 低字节
 24         if (data != null) {
 25             for (byte b : data) {
 26                 int Index = Low ^ b;
 27                 Low = High ^ CRC16TABLE_LO[Index];
 28                 High = CRC16TABLE_HI[Index];
 29             }
 30         }
 31         return (short) (~((High &lt;&lt; 8) + Low)); // 取反
 32     }
 33
 34     /**
 35      * 检查给定长度数据的16位CRC是否正确
 36      *
 37      * @param data
 38      *            要校验的字节数组
 39      * @return true：正确 false：错误
 40      *
 41      *         &lt;reamrks&gt; 字节数组最后2个字节为校验码，且低字节在前面，高字节在后面 &lt;/reamrks&gt;
 42      */
 43     public static boolean IsCrc16Good(byte[] data) {
 44         // 初始化
 45         int High = 0xFF;
 46         int Low = 0xFF;
 47         if (data != null) {
 48             for (byte b : data) {
 49                 int Index = Low ^ b;
 50                 Low = High ^ CRC16TABLE_LO[Index];
 51                 High = CRC16TABLE_HI[Index];
 52             }
 53         }
 54
 55         return (High == 0xF0 &amp;&amp; Low == 0xB8);
 56     }
 57
 58     /**
 59      * CRC16查找表高字节
 60      */
 61     private static final int[] CRC16TABLE_HI = { 0x00, 0x11, 0x23, 0x32, 0x46,
 62             0x57, 0x65, 0x74, 0x8C, 0x9D, 0xAF, 0xBE, 0xCA, 0xDB, 0xE9, 0xF8,
 63             0x10, 0x01, 0x33, 0x22, 0x56, 0x47, 0x75, 0x64, 0x9C, 0x8D, 0xBF,
 64             0xAE, 0xDA, 0xCB, 0xF9, 0xE8, 0x21, 0x30, 0x02, 0x13, 0x67, 0x76,
 65             0x44, 0x55, 0xAD, 0xBC, 0x8E, 0x9F, 0xEB, 0xFA, 0xC8, 0xD9, 0x31,
 66             0x20, 0x12, 0x03, 0x77, 0x66, 0x54, 0x45, 0xBD, 0xAC, 0x9E, 0x8F,
 67             0xFB, 0xEA, 0xD8, 0xC9, 0x42, 0x53, 0x61, 0x70, 0x04, 0x15, 0x27,
 68             0x36, 0xCE, 0xDF, 0xED, 0xFC, 0x88, 0x99, 0xAB, 0xBA, 0x52, 0x43,
 69             0x71, 0x60, 0x14, 0x05, 0x37, 0x26, 0xDE, 0xCF, 0xFD, 0xEC, 0x98,
 70             0x89, 0xBB, 0xAA, 0x63, 0x72, 0x40, 0x51, 0x25, 0x34, 0x06, 0x17,
 71             0xEF, 0xFE, 0xCC, 0xDD, 0xA9, 0xB8, 0x8A, 0x9B, 0x73, 0x62, 0x50,
 72             0x41, 0x35, 0x24, 0x16, 0x07, 0xFF, 0xEE, 0xDC, 0xCD, 0xB9, 0xA8,
 73             0x9A, 0x8B, 0x84, 0x95, 0xA7, 0xB6, 0xC2, 0xD3, 0xE1, 0xF0, 0x08,
 74             0x19, 0x2B, 0x3A, 0x4E, 0x5F, 0x6D, 0x7C, 0x94, 0x85, 0xB7, 0xA6,
 75             0xD2, 0xC3, 0xF1, 0xE0, 0x18, 0x09, 0x3B, 0x2A, 0x5E, 0x4F, 0x7D,
 76             0x6C, 0xA5, 0xB4, 0x86, 0x97, 0xE3, 0xF2, 0xC0, 0xD1, 0x29, 0x38,
 77             0x0A, 0x1B, 0x6F, 0x7E, 0x4C, 0x5D, 0xB5, 0xA4, 0x96, 0x87, 0xF3,
 78             0xE2, 0xD0, 0xC1, 0x39, 0x28, 0x1A, 0x0B, 0x7F, 0x6E, 0x5C, 0x4D,
 79             0xC6, 0xD7, 0xE5, 0xF4, 0x80, 0x91, 0xA3, 0xB2, 0x4A, 0x5B, 0x69,
 80             0x78, 0x0C, 0x1D, 0x2F, 0x3E, 0xD6, 0xC7, 0xF5, 0xE4, 0x90, 0x81,
 81             0xB3, 0xA2, 0x5A, 0x4B, 0x79, 0x68, 0x1C, 0x0D, 0x3F, 0x2E, 0xE7,
 82             0xF6, 0xC4, 0xD5, 0xA1, 0xB0, 0x82, 0x93, 0x6B, 0x7A, 0x48, 0x59,
 83             0x2D, 0x3C, 0x0E, 0x1F, 0xF7, 0xE6, 0xD4, 0xC5, 0xB1, 0xA0, 0x92,
 84             0x83, 0x7B, 0x6A, 0x58, 0x49, 0x3D, 0x2C, 0x1E, 0x0F };
 85
 86     /**
 87      * CRC16查找表低字节
 88      */
 89     private static final int[] CRC16TABLE_LO = { 0x00, 0x89, 0x12, 0x9B, 0x24,
 90             0xAD, 0x36, 0xBF, 0x48, 0xC1, 0x5A, 0xD3, 0x6C, 0xE5, 0x7E, 0xF7,
 91             0x81, 0x08, 0x93, 0x1A, 0xA5, 0x2C, 0xB7, 0x3E, 0xC9, 0x40, 0xDB,
 92             0x52, 0xED, 0x64, 0xFF, 0x76, 0x02, 0x8B, 0x10, 0x99, 0x26, 0xAF,
 93             0x34, 0xBD, 0x4A, 0xC3, 0x58, 0xD1, 0x6E, 0xE7, 0x7C, 0xF5, 0x83,
 94             0x0A, 0x91, 0x18, 0xA7, 0x2E, 0xB5, 0x3C, 0xCB, 0x42, 0xD9, 0x50,
 95             0xEF, 0x66, 0xFD, 0x74, 0x04, 0x8D, 0x16, 0x9F, 0x20, 0xA9, 0x32,
 96             0xBB, 0x4C, 0xC5, 0x5E, 0xD7, 0x68, 0xE1, 0x7A, 0xF3, 0x85, 0x0C,
 97             0x97, 0x1E, 0xA1, 0x28, 0xB3, 0x3A, 0xCD, 0x44, 0xDF, 0x56, 0xE9,
 98             0x60, 0xFB, 0x72, 0x06, 0x8F, 0x14, 0x9D, 0x22, 0xAB, 0x30, 0xB9,
 99             0x4E, 0xC7, 0x5C, 0xD5, 0x6A, 0xE3, 0x78, 0xF1, 0x87, 0x0E, 0x95,
100             0x1C, 0xA3, 0x2A, 0xB1, 0x38, 0xCF, 0x46, 0xDD, 0x54, 0xEB, 0x62,
101             0xF9, 0x70, 0x08, 0x81, 0x1A, 0x93, 0x2C, 0xA5, 0x3E, 0xB7, 0x40,
102             0xC9, 0x52, 0xDB, 0x64, 0xED, 0x76, 0xFF, 0x89, 0x00, 0x9B, 0x12,
103             0xAD, 0x24, 0xBF, 0x36, 0xC1, 0x48, 0xD3, 0x5A, 0xE5, 0x6C, 0xF7,
104             0x7E, 0x0A, 0x83, 0x18, 0x91, 0x2E, 0xA7, 0x3C, 0xB5, 0x42, 0xCB,
105             0x50, 0xD9, 0x66, 0xEF, 0x74, 0xFD, 0x8B, 0x02, 0x99, 0x10, 0xAF,
106             0x26, 0xBD, 0x34, 0xC3, 0x4A, 0xD1, 0x58, 0xE7, 0x6E, 0xF5, 0x7C,
107             0x0C, 0x85, 0x1E, 0x97, 0x28, 0xA1, 0x3A, 0xB3, 0x44, 0xCD, 0x56,
108             0xDF, 0x60, 0xE9, 0x72, 0xFB, 0x8D, 0x04, 0x9F, 0x16, 0xA9, 0x20,
109             0xBB, 0x32, 0xC5, 0x4C, 0xD7, 0x5E, 0xE1, 0x68, 0xF3, 0x7A, 0x0E,
110             0x87, 0x1C, 0x95, 0x2A, 0xA3, 0x38, 0xB1, 0x46, 0xCF, 0x54, 0xDD,
111             0x62, 0xEB, 0x70, 0xF9, 0x8F, 0x06, 0x9D, 0x14, 0xAB, 0x22, 0xB9,
112             0x30, 0xC7, 0x4E, 0xD5, 0x5C, 0xE3, 0x6A, 0xF1, 0x78 };
113 }</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p> </p>
<h2>C代码</h2>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg"></p>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<pre>  1 using System;
  2 using System.Collections.Generic;
  3 using System.Linq;
  4 using System.Text;
  5
  6 namespace GovConsoleSuperior.Common
  7 {
  8     /// &lt;summary&gt;
  9     /// 循环冗余检验：CRC-16-CCITT查表法
 10     /// &lt;/summary&gt;
 11     public static partial class CRCITU
 12     {
 13         /// &lt;summary&gt;
 14         /// 计算给定长度数据的16位CRC
 15         /// &lt;/summary&gt;
 16         /// &lt;param name="data"&gt;要计算CRC的字节数组&lt;/param&gt;
 17         /// &lt;returns&gt;CRC值&lt;/returns&gt;
 18         public static byte[] GetCrc16(Byte[] buffer)
 19         {
 20             int crc = 0;
 21             int l = buffer.Length;
 22             for (int i = 0; i &lt; l; i++)
 23             {
 24                 int by = (crc &gt;&gt; 8) &amp; 0xff;
 25                 crc = (crc &amp; 0xffff) &lt;&lt; 8;
 26                 crc = (crc ^ table[(buffer[i] ^ by) &amp; 0xff]) &amp; 0xffff;
 27             }
 28
 29             return GetCRCBytes(crc);
 30
 31         }
 32         /// &lt;summary&gt;
 33         /// 获取CRC字节数组
 34         /// &lt;/summary&gt;
 35         /// &lt;param name="crc"&gt;整形的CRC&lt;/param&gt;
 36         /// &lt;returns&gt;两字节的CRC字节数组&lt;/returns&gt;
 37         private static byte[] GetCRCBytes(int crc)
 38         {
 39             byte[] result = BitConverter.GetBytes(crc);
 40             Array.Resize(ref result, 2);                //只截取前面两个byte字节
 41
 42             return result;
 43         }
 44
 45
 46
 47
 48         static int[] table = {
 49             0x0000, 0x1021, 0x2042, 0x3063, 0x4084, 0x50a5, 0x60c6, 0x70e7, 0x8108, 0x9129, 0xa14a,
 50             0xb16b, 0xc18c, 0xd1ad, 0xe1ce, 0xf1ef, 0x1231, 0x0210, 0x3273, 0x2252, 0x52b5, 0x4294, 0x72f7, 0x62d6,
 51             0x9339, 0x8318, 0xb37b, 0xa35a, 0xd3bd, 0xc39c, 0xf3ff, 0xe3de, 0x2462, 0x3443, 0x0420, 0x1401, 0x64e6,
 52             0x74c7, 0x44a4, 0x5485, 0xa56a, 0xb54b, 0x8528, 0x9509, 0xe5ee, 0xf5cf, 0xc5ac, 0xd58d, 0x3653, 0x2672,
 53             0x1611, 0x0630, 0x76d7, 0x66f6, 0x5695, 0x46b4, 0xb75b, 0xa77a, 0x9719, 0x8738, 0xf7df, 0xe7fe, 0xd79d,
 54             0xc7bc, 0x48c4, 0x58e5, 0x6886, 0x78a7, 0x0840, 0x1861, 0x2802, 0x3823, 0xc9cc, 0xd9ed, 0xe98e, 0xf9af,
 55             0x8948, 0x9969, 0xa90a, 0xb92b, 0x5af5, 0x4ad4, 0x7ab7, 0x6a96, 0x1a71, 0x0a50, 0x3a33, 0x2a12, 0xdbfd,
 56             0xcbdc, 0xfbbf, 0xeb9e, 0x9b79, 0x8b58, 0xbb3b, 0xab1a, 0x6ca6, 0x7c87, 0x4ce4, 0x5cc5, 0x2c22, 0x3c03,
 57             0x0c60, 0x1c41, 0xedae, 0xfd8f, 0xcdec, 0xddcd, 0xad2a, 0xbd0b, 0x8d68, 0x9d49, 0x7e97, 0x6eb6, 0x5ed5,
 58             0x4ef4, 0x3e13, 0x2e32, 0x1e51, 0x0e70, 0xff9f, 0xefbe, 0xdfdd, 0xcffc, 0xbf1b, 0xaf3a, 0x9f59, 0x8f78,
 59             0x9188, 0x81a9, 0xb1ca, 0xa1eb, 0xd10c, 0xc12d, 0xf14e, 0xe16f, 0x1080, 0x00a1, 0x30c2, 0x20e3, 0x5004,
 60             0x4025, 0x7046, 0x6067, 0x83b9, 0x9398, 0xa3fb, 0xb3da, 0xc33d, 0xd31c, 0xe37f, 0xf35e, 0x02b1, 0x1290,
 61             0x22f3, 0x32d2, 0x4235, 0x5214, 0x6277, 0x7256, 0xb5ea, 0xa5cb, 0x95a8, 0x8589, 0xf56e, 0xe54f, 0xd52c,
 62             0xc50d, 0x34e2, 0x24c3, 0x14a0, 0x0481, 0x7466, 0x6447, 0x5424, 0x4405, 0xa7db, 0xb7fa, 0x8799, 0x97b8,
 63             0xe75f, 0xf77e, 0xc71d, 0xd73c, 0x26d3, 0x36f2, 0x0691, 0x16b0, 0x6657, 0x7676, 0x4615, 0x5634, 0xd94c,
 64             0xc96d, 0xf90e, 0xe92f, 0x99c8, 0x89e9, 0xb98a, 0xa9ab, 0x5844, 0x4865, 0x7806, 0x6827, 0x18c0, 0x08e1,
 65             0x3882, 0x28a3, 0xcb7d, 0xdb5c, 0xeb3f, 0xfb1e, 0x8bf9, 0x9bd8, 0xabbb, 0xbb9a, 0x4a75, 0x5a54, 0x6a37,
 66             0x7a16, 0x0af1, 0x1ad0, 0x2ab3, 0x3a92, 0xfd2e, 0xed0f, 0xdd6c, 0xcd4d, 0xbdaa, 0xad8b, 0x9de8, 0x8dc9,
 67             0x7c26, 0x6c07, 0x5c64, 0x4c45, 0x3ca2, 0x2c83, 0x1ce0, 0x0cc1, 0xef1f, 0xff3e, 0xcf5d, 0xdf7c, 0xaf9b,
 68             0xbfba, 0x8fd9, 0x9ff8, 0x6e17, 0x7e36, 0x4e55, 0x5e74, 0x2e93, 0x3eb2, 0x0ed1, 0x1ef0
 69             };
 70
 71         /// &lt;summary&gt;
 72         /// 检查给定长度数据的16位CRC是否正确
 73         /// &lt;/summary&gt;
 74         /// &lt;param name="FromHeadToVaild"&gt;要校验的字节数组&lt;/param&gt;
 75         /// &lt;returns&gt;
 76         ///     true：正确
 77         ///     false：错误
 78         /// &lt;/returns&gt;
 79         /// &lt;reamrks&gt;
 80         /// 字节数组最后2个字节为校验码
 81         /// &lt;/reamrks&gt;
 82         public static Boolean IsCrc16Good(Byte[] FromHeadToCRC)
 83         {
 84             byte[] FromHeadToVaild = GetHeadToVaildData(FromHeadToCRC);     //头到验证域
 85             byte[] CRCFromPackage = GetCRCFromPackage(FromHeadToCRC);       //获取客户端传来的包中的CRC数组
 86             byte[] TrueCRCValue = GetCrc16(FromHeadToVaild);                //获取客户端传来的包应该的CRC数组
 87             return BytesEquals(CRCFromPackage, TrueCRCValue);
 88         }
 89         /// &lt;summary&gt;
 90         /// 比较两个字节数组是否相等
 91         /// &lt;/summary&gt;
 92         /// &lt;param name="b1"&gt;byte数组1&lt;/param&gt;
 93         /// &lt;param name="b2"&gt;byte数组2&lt;/param&gt;
 94         /// &lt;returns&gt;是否相等&lt;/returns&gt;
 95         private static bool BytesEquals(byte[] b1, byte[] b2)
 96         {
 97             if (b1.Length != b2.Length) return false;
 98             if (b1 == null || b2 == null) return false;
 99             for (int i = 0; i &lt; b1.Length; i++)
100                 if (b1[i] != b2[i])
101                     return false;
102             return true;
103         }
104
105
106         /// &lt;summary&gt;
107         /// 获取客户端传来的包中的CRC数组
108         /// &lt;/summary&gt;
109         /// &lt;param name="FromHeadToCRC"&gt;从头到CRC校验域&lt;/param&gt;
110         /// &lt;returns&gt;CRC数组&lt;/returns&gt;
111         private static byte[] GetCRCFromPackage(byte[] FromHeadToCRC)
112         {
113             int iCRCLen = 2;                                                             //因为CRC占两个字节
114             byte[] CRCValue = new byte[iCRCLen];                                          //用于存储包中CRC的值
115             int i;
116             for (i = 0; i &lt; iCRCLen; i++)                                                 //得到一个临时字节数组
117             {
118                 CRCValue[i] = FromHeadToCRC[FromHeadToCRC.Length - iCRCLen + i];
119             }
120             return CRCValue;
121         }
122         /// &lt;summary&gt;
123         /// 得到从头到有效数据的数据（不包含CRC验证域）
124         /// &lt;/summary&gt;
125         /// &lt;param name="FromHeadToCRC"&gt;&lt;/param&gt;
126         /// &lt;returns&gt;&lt;/returns&gt;
127         private static byte[] GetHeadToVaildData(byte[] FromHeadToCRC)
128         {
129             int iLengh = FromHeadToCRC.Length - 2;               //因为CRC占两个字节
130             byte[] FromHeadToVaild = new byte[iLengh];       //用于存储包头到有效数据域的bytes
131             int i;
132             for (i = 0; i &lt; iLengh; i++)                     //得到一个临时字节数组
133             {
134                 FromHeadToVaild[i] = FromHeadToCRC[i];
135             }
136             return FromHeadToVaild;
137
138         }
139
140     }
141
142 }</pre>
<p><a><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvY29tbW9uLmNuYmxvZ3MuY29tL2ltYWdlcy9jb3B5Y29kZS5naWY=.jpg"></a></p>
<p> </p>
<p>作者：<a href="http://www.cnblogs.com/kissazi2/" rel="external nofollow noreferrer">kissazi2</a> <br />
出处：<a href="http://www.cnblogs.com/kissazi2/" rel="external nofollow noreferrer">http://www.cnblogs.com/kissazi2/</a> <br />
本文版权归作者所有，欢迎转载，但未经作者同意必须保留此段声明，且在文章页面明显位置给出原文连接，否则保留追究法律责任的权利。</p>
<p>转载：http://www.cnblogs.com/kissazi2/p/3341461.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 18:50:38</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>C#,Java,C -循环冗余检验：CRC-16-CCITT查表法的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRqvDBb.html" rel="bookmark">半字节查表法提问-求教CRC半字节查表法原理和表的生成算法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 求教CRC半字节查表法原理和表的生成算法 如题 正在研究CRC16的半字节查表法,请各位大神前辈指点下这个的原理和表生成的算法			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJOwEJb.html" rel="bookmark">java累加和校验实现方式16进制&lpar;推荐&rpar;&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				已知一个字符串,求该字符串的16进制累加和,已知一段字符串和校验码,校验和累加是否合法,话不多说了直接上代码 public static String makeChecksum(String data) { if (data == null || data.equals(&quot;&quot;)) { return &quot;&quot;; } int total = 0; int len = data.length(); int num = 0; while (num &lt; len) { Str			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOwkr3z.html" rel="bookmark">java的循环语句</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				while,do-while和for控制着循环,有时将其划分为&quot;反复语句&quot;.除非用于控制反复的布尔表达式得到&quot;假&quot;的结果,否则语句会重复执行下去.while循环的格式如下: while(布尔表达式) 语句 在循环刚开始时,会计算一次&quot;布尔表达式&quot;的值.而对于后来每一次额外的循环,都会在开始前重新计算一次. 下面这个简单的例子可产生随机数,直到符合特定的条件为止:   //: WhileTest.java // Demonstrates the w			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQN82wM.html" rel="bookmark">这段java for循环代码的结果怎么不对呢？DOS 输出结果为800&period;0，编译也没有啥问题啊。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 这段java for循环代码的结果怎么不对呢?DOS 输出结果为800.0,编译也没有啥问题啊. 如题,代码如下: public class Example41_3 { public static void main(String args[]){ float i=0; double sum=0; for(i=1;i&lt;=3;i++); { sum+=8*(Math.pow(10.0,(i-1))); } System.out.println(&quot;计算8+88+888+8888+--			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MywBddz.html" rel="bookmark">java for循环体循环一定次数终止程序重新开始循环（不是break，就是点那个正方形的那种终止）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 java for循环体循环一定次数终止程序重新开始循环(不是break,就是点那个正方形的那种终止) for(;;){ System.out.println(&quot;跳出来&quot;); //终止循环体,在保留aid最后一次值的基础上,程序从这个位置重新开始运行. for(aid=91322;aid&lt;=2000000;aid++){ q=bili.inputav(aid,page); j1++; System.out.println(aid+&quot;连续扫描&quot;+j1+&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDW56Kp.html" rel="bookmark">class文件-java for循环里的变量反编译出问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 java for循环里的变量反编译出问题 for(int i=0;i&lt;10;i++){ int k = 10; } 编译出的class文件,用jd-gui反编译出来的java文件,结果变成了 for(int i=0;i&lt;10;i++){ i = 10; } 然后如果是 for(int i=0;i&lt;10;i++){ int k = 10; System.out.println(k); } 则反编译出来的就是 for(int i=0;i&lt;10;i++){ int k = 10			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwxwYOb.html" rel="bookmark">java中循环添加按钮后 要添加监听这么区分按钮</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 java中循环添加按钮后 要添加监听这么区分按钮 while(rs.next()){ String friendId=rs.getString(&quot;&quot;friendid&quot;&quot;); jb=new JButton(); jb.setText(friendId); jb.setBounds(10i10030); i=i+50; jsp.add(jb); } 这句话循环读数据库去除ID然后添加按钮,但是这么区分 我试验了下 监听只能最后一个按钮能行 其他不行 解决方案			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zV0D6kM.html" rel="bookmark">java 10进制转16进制带ox格式输出</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 java 10进制转16进制带ox格式输出 请教:java 怎么把10进制转16进制并且 带ox格式输出 如 60(10进制) 输出 : 0x00,0x00,0x00,0x3c 解决方案 如下代码: public static void main(String[] args) throws IOException { int num=3000; ByteArrayOutputStream baos=new ByteArrayOutputStream(); DataOutputStrea			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5Z686z.html" rel="bookmark">java for循环问题放入一条string中</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 java for循环问题放入一条string中 for(int i=1; i&lt;5;++i){ System.out.println(i);} i的输出值是1,2,3,4:有什么办法能够把1234放在string中下面的这个样子如果输出是 &quot; test1 AND table 1,test2 AND table 2,test3 AND table 3,test4 AND table4;该怎么办? 解决方案 StringBuffer sb = new StringBuffer(); f			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnDrbG.html" rel="bookmark" class="title">如何用c&num;来制作一个activeX控件或类似的东西</a>
					<div>
						active|activex|控件 Q cat: 操作系统: 2000/xp 编程工具: vs.net 2003 /c# 问题: 我想制作一个activeX控件或类似的东西,有用户界面的,然后想在ie ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvGWAp.html" rel="bookmark" class="title">Linux忘记root密码怎么办？</a>
					<div>
						开篇前言:Linux系统的root账号是非常重要的一个账号,也是权限最大的一个账号,但是有时候忘了 root密码怎么办?总不能重装系统吧,这个是下下策,其实Linux系统中,如果忘记了root账号密码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz73aRz.html" rel="bookmark" class="title">Flash中开启全屏的窗口</a>
					<div>
						难度: 中级软件环境: Flash 4 or 5, NS or IE 4 or higher. 我们在这个例子中有很多的需求,但是我不是一个JAVACSCRIPT程序员,所以我请人在网页中实现这一效果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKGw5b.html" rel="bookmark" class="title">6月末SEO界风起云涌</a>
					<div>
						6月是不寻常的一个月,特别是6月末,整个SEO界都围绕着几件大事讨论着,可以说在整个SEO界刮起了不小的旋风.下面就6月末SEO界的几件事进行一下回顾. 1.狼雨SEO 关注指数:★★★★★ 狼雨SE ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyBdJp.html" rel="bookmark" class="title">陈正杰：如何选择最好的网站关键词</a>
					<div>
						大家好,我是陈正杰.今天我们一起来分享如何选择最好的网站关键词.凭多年网络营销经验总结而出:关键词选择的四大标准:一性(相关性)一率(转化率)一量(搜索量)一度(竞争度). 第一:(相关性)指的是关键 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7OV6b.html" rel="bookmark" class="title">关于XSL的基础知识</a>
					<div>
						什么是XSL 全称ExtensibleStyleLanguage,中文译作扩展样式语言,用于格式化XML文档,它由两部分组成. 1(XSLT):XSLTransformationLanguage(XS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myrny4p.html" rel="bookmark" class="title">C&plus;&plus;中的引用&lpar;reference&rpar;</a>
					<div>
						1.简介 引用是C++引入的新语言特性.从语意上来说,引用就是一个变量的别名,就好象古代人的&quot;字&quot;和&quot;号&quot;,东坡居士和苏轼只是一个人的不同称呼.对引用的操作对变 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLGweb.html" rel="bookmark" class="title">TP-Link无线路由器的宽带限速功能怎么设置</a>
					<div>
						  TP-Link无线路由器的宽带限速功能设置方法 1.打开TP-Link路由器的Web管理界面:在浏览输入192.168.1.1(TP-Link路由器默认的管理地址)---&gt;输入用户名和密码, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNEG5yb.html" rel="bookmark" class="title">二维指针动态分配内存连续问题深入分析</a>
					<div>
						当我们定义一个二维指针时,如果需要存储相应的数据,就需要我们动态的分配内存,这时,有一点是需要注意的,分配内存的方法不同,内存的连续性也是不相同的   首先,小编先贴出测试代码: 复制代码 代码如下: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlR6kaz.html" rel="bookmark" class="title">解决IE9启动速度过慢的方法</a>
					<div>
						IE9启动的时候弹出提示条以后,点击&quot;选择加载项&quot;,再查找影响速度的插件,决定是否&quot;禁用&quot;. 在未弹出该提醒的情况下,我们也可以打开&quot;管理加载项&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYj0g6p.html" rel="bookmark" class="title">使用iWebOffice实现电子签章</a>
					<div>
						摘要:随着信息化的发展电子签章已经越来越多的被用到很多OA系统中,今天就来看一下如何使用iWebOffice来实现电子签章功能. 内容: 1.iWebOffice2003的基本原理 2.使用iWebO ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7L1kz.html" rel="bookmark" class="title">千年汉字遭遇的二十年劫难</a>
					<div>
						题记:&quot;想让中国衰微,不是寄托在几代后的年轻人,而是让中国汉字渐远其使用环境.&quot;此言不是耸人听闻,而是近代西方政治家提出的别有意味的话语.留意汉字的现状,关注国人使用汉字的形势,都 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lOnKb.html" rel="bookmark" class="title">E4X教程&lbrack;2&rsqb; - 访问 XML 子节点</a>
					<div>
						访问 XML 子节点 JavaScript 对象通常使用 . 或 [] 来设置性质. var a = {}; a.foo = 1; a[&quot;bar&quot;] = 2; 在 E4X 中,点( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b32QRNz.html" rel="bookmark" class="title">windows下配置nginx&plus;php环境</a>
					<div>
						刚看到nginx这个词,我很好奇它的读法(engine x),我的直译是&quot;引擎x&quot;,一般引&quot;擎代&quot;表了性能,而&quot;x&quot;大多出现是表示&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPEaDp.html" rel="bookmark" class="title">在使用link环境制作一款《订餐软件》，各种角色的权限的控制是什么方式实现？思路？</a>
					<div>
						问题描述 在使用link环境制作一款&lt;订餐软件&gt;,各种角色的权限的控制是什么方式实现?思路? 在使用link环境制作一款&lt;订餐软件&gt;,各种角色的权限的控制是什么方式实现?思路? ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8AZD3z.html" rel="bookmark" class="title">word打开报应用程序错误</a>
					<div>
						问题描述 word打开后报应用程序错误?如何解决?除去重装系统. 解决方案 解决方案二:重装word解决方案三:只能重装了··我的也是					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeR69Ob.html" rel="bookmark" class="title">WPF&sol;Silverlight中图形的平移&comma;缩放&comma;旋转&comma;倾斜变换演示</a>
					<div>
						原文:WPF/Silverlight中图形的平移,缩放,旋转,倾斜变换演示 为方便描述, 这里仅以正方形来做演示, 其他图形从略. 运行时效果图: XAML代码:// Transform.XAML & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQB1m0M.html" rel="bookmark" class="title">jquery-main-aim-获取某一行表格的修改数值</a>
					<div>
						问题描述 获取某一行表格的修改数值 现在我的jsp是用hibernate+struts2+jquery编的,在页面以表格table的方式显示数据库中的记录之后,想就在这个表格中修改一行记录,比方说双击 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKk9Vb.html" rel="bookmark" class="title">ios-Xcode中的怎么设置OC与C&plus;&plus;混编，编译通过</a>
					<div>
						问题描述 Xcode中的怎么设置OC与C++混编,编译通过 Compile Sources As 切换回According to File Type,把AppDelegate文件后缀修改成.mm.但是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRB92p.html" rel="bookmark" class="title">mvc4-&amp;amp&semi;amp&semi;quot&semi;一般&vert;好&vert;很好&amp;amp&semi;amp&semi;quot&semi;怎样获取到&OpenCurlyQuote;一般&rsquo;&OpenCurlyQuote;好&rsquo;&OpenCurlyQuote;很好&rsquo;</a>
					<div>
						问题描述 &quot;一般|好|很好&quot;怎样获取到'一般''好''很好' &quot;一般|好|很好&quot;怎样获取到'一般''好''很好' 图片就不上了,C# MVC4做的,求帮助 解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xWLXb.html" rel="bookmark" class="title">PHP 执行系统外部命令 system&lpar;&rpar; exec&lpar;&rpar; passthru&lpar;&rpar;&lowbar;php技巧</a>
					<div>
						区别: system() 输出并返回最后一行shell结果. exec() 不输出结果,返回最后一行shell结果,所有结果可以保存到一个返回的数组里面. passthru() 只调用命令,把命令的运 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwgLZM.html" rel="bookmark" class="title">eclipse删除后重新安装时出错</a>
					<div>
						问题描述 eclipse删除后重新安装时出错 具体错误提示如下: [2016-03-10 23:07:32] Executing bootstrap tasks [2016-03-10 23:07:3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodgZBM.html" rel="bookmark" class="title">c-求中位数的中位数那里好像有问题，我找不出来。求帮忙！感激！</a>
					<div>
						问题描述 求中位数的中位数那里好像有问题,我找不出来.求帮忙!感激! 代码求第k小的数.编译过了,求中位数的中位数结果不对 #include&lt;stdio.h&gt; #include&lt;st ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodQwjM.html" rel="bookmark" class="title">开源PaaS评估：OpenShift vs&period; CloudFoundry</a>
					<div>
						在整合完成后再更改开源云开发工具是很困难的事.开发人员和IT员工必须对使用和支持该工具都感到得心应手,并且做好长期使用的准备.这需要对开源工具进行广泛的研究,以及丰富的评估测试. 云开发平台实现的目标 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAkVjb.html" rel="bookmark" class="title">上海猎头：最近手上一些职位，大家分享一下~</a>
					<div>
						问题描述 资方在上海浦东软件园(地铁二号线班车接送)委托物色几个职位,大家符合条件的有兴趣或有朋友条件合适请及时联系.高级开发工程师一.工作职责1.负责研发小组的核心研发工作2.负责依据系统架构设计. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22KwBb.html" rel="bookmark" class="title">Mybatis 示例之 Association</a>
					<div>
						接下来的文章中,关于Mybatis的示例,全部来自于Mybatis代码中的单元测试代码,通过这些代码能够学习Mybatis中很有用的知识,这些内容在doc文档中可能只是简单提到了,或者有一些文字说明, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW71deM.html" rel="bookmark" class="title">情人节营销：以浪漫拉动低迷</a>
					<div>
						保经济危机导致的并非是浪漫低迷,以浪漫的名义拉动内需,也是另一种振兴策略一个愿打,一个愿挨,金钱为媒,以爱之名 &quot;爱她就请她吃XXX&quot;.&quot;送你一杯子,爱你一辈子&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj8al6p.html" rel="bookmark" class="title">php使用websocket示例详解&lowbar;php实例</a>
					<div>
						下面我画了一个图演示 client 和 server 之间建立 websocket 连接时握手部分,这个部分在 node 中可以十分轻松的完成,因为 node 提供的 net 模块已经对 socket ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn8d0rb.html" rel="bookmark" class="title">没有sa密码无法集成windows身份验证登录的解决方法&lowbar;MsSql</a>
					<div>
						SQL登录时如果采用windows集成身份验证,登录框将会以&quot;机器名\当前系统用户名&quot;的格式显示登录名,而且登录名和密码都是灰色的,不允许用户输入. 了解到同事刚刚修改了服务器的机 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44Bn9z.html" rel="bookmark" class="title">Linux中Oracle服务启动和停止脚本与开机自启动&lowbar;Linux</a>
					<div>
						在CentOS 6.3下安装完Oracle 10g R2,重开机之后,你会发现Oracle没有自行启动,这是正常的,因为在Linux下安装Oracle的确不会自行启动,必须要自行设定相关参数,首先先介 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
